<?php

namespace App\Controllers\Admin\Customer;

use App\Entities\Customer\AccountEntity;
use App\Entities\Customer\ClientEntity;
use App\Helpers\Customer\AccountHelper;
use App\Services\Customer\AccountService;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class AccountController extends CustomerController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): AccountService
    {
        if (!$this->_service) {
            $this->_service = new AccountService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): AccountHelper
    {
        if (!$this->_helper) {
            $this->_helper = new AccountHelper($this->request);
        }
        return $this->_helper;
    }
    //Index,FieldForm관련.

    private function setAccountBalance(array $formDatas): ClientEntity
    {
        //account_balance 체크
        $entity = $this->getClientService()->getEntity($formDatas['clientinfo_uid']);
        if (!$entity) {
            throw new \Exception("{$formDatas['clientinfo_uid']}에 대한 고객정보를 찾을수 없습니다.");
        }
        $amount = intval($formDatas['amount']);
        if ($formDatas['status'] === DEFAULTS['STATUS']) { //입금, 쿠폰추가
            $entity = $this->getClientService()->deposit($entity, 'account_balance',   $amount);
        } else { // 출금, 쿠폰사용
            $entity = $this->getClientService()->withdrawal($entity, 'account_balance',   $amount);
        }
        return $entity;
    }
    protected function create_process(array $formDatas): AccountEntity
    {
        $entity = parent::create_process($formDatas);
        //고객예치금처리
        $this->setAccountBalance($formDatas);
        return $entity;
    }
}
